Processing expired messages

Serkan Kocak
Transaction and Messaging Systems Specialist (Turkey)	cXephon



CBL NODYNAM,LIB,OBJECT,RENT,RES,APOST
       IDENTIFICATION DIVISION.
       PROGRAM-ID. MQREMEXP.
       AUTHOR.   SERKAN KOCAK.
       DATE-WRITTEN. JAN, 2000.
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       I-O-CONTROL.
       DATA DIVISION.
       FILE SECTION.
       WORKING-STORAGE SECTION.
       01  TARGET-MSGID    PIC X(24) VALUE 'TISYS REMOVE EXPIRED MSG'.
       01  TARGET-CORRELID PIC X(24) VALUE 'TISYS REMOVE EXPIRED MSG'.
       01  W01-MQM-NAME                PIC X(48) VALUE SPACES.
       01  W01-QUEUE-NAME              PIC X(48) VALUE SPACES.
       01  W02-MQM                     PIC X(48) VALUE SPACES.
       01  W02-OBJECT                  PIC X(48) VALUE SPACES.
       01  W03-BUFFER-LENGTH           PIC S9(9) BINARY  VALUE 5200.
       01  W03-HCONN                   PIC S9(9) BINARY.
       01  W03-OPTIONS                 PIC S9(9) BINARY.
       01  W03-HOBJ                    PIC S9(9) BINARY.
       01  W03-DATA-LENGTH             PIC S9(9) BINARY.
       01  W03-COMPCODE                PIC S9(9) BINARY.
       01  W03-REASON                  PIC S9(9) BINARY.
       01  W03-MESSAGE-BUFFER          PIC X(5200).
       01  W05-MQM-OBJECT-DESCRIPTOR.
           COPY CMQODV.
       01  W05-MQM-MESSAGE-DESCRIPTOR.
           COPY CMQMDV.
       01  W05-MQM-GET-MESSAGE-OPTIONS.
           COPY CMQGMOV.
       01  W05-MQM-CONSTANTS.
           COPY CMQV.
       01  W06-CSQ4-OK             PIC S9(4) VALUE 0.
       01  W06-CSQ4-WARNING        PIC S9(4) VALUE 4.
       01  W06-CSQ4-ERROR          PIC S9(4) VALUE 8.
       01  W07-DISPLAY.
           05 W07-QNAME            PIC X(48).
           05 W07-ACTION           PIC X(10).
       LINKAGE SECTION
       01  PARMDATA.
           05  PARM-LEN                PIC S9(03) BINARY.
           05  PARM-STRING             PIC X(100).
       PROCEDURE DIVISION USING PARMDATA.
       A-MAIN SECTION.
           PERFORM GET-PARAMETERS
              THRU GET-PARAMETERS-EXIT.
           PERFORM MAIN-WORK
              THRU MAIN-WORK-EXIT.
       GET-PARAMETERS.      
      * QMANAGER NAME AND THE DEAD_LETTER_Q NAME SHOULB BE 
      * BE GIVEN AS INPUT PARAMETERS FROM THE INVOKED JCL       
           IF PARM-LEN = 0 THEN
              DISPLAY 'MQREMEXP: NO PARAMAETER SPECIFIED, GIVE QMGR'
              DISPLAY 'MQREMEXP: AND QUEUE NAME SEPARATED BY COMMA.'
              STOP RUN
           END-IF.
           UNSTRING PARM-STRING DELIMITED BY ALL ','
                                   INTO W02-MQM
                                        W02-OBJECT.
           MOVE W02-MQM    TO W01-MQM-NAME.
           MOVE W02-OBJECT TO W01-QUEUE-NAME.
           IF W02-MQM = SPACES OR W02-MQM = LOW-VALUES THEN
              DISPLAY 'MQREMEXP: DEFAULT QMGR USED'
           END-IF.
           IF W02-OBJECT = SPACES OR W02-OBJECT = LOW-VALUES THEN
              DISPLAY 'MQREMEXP: SPECIFY DEAD_LETTER_QUEUE NAME'
              STOP RUN
           END-IF.
       GET-PARAMETERS-EXIT.
           EXIT.
       MAIN-WORK.
      * CONNECT TO THE QMANAGER
           CALL 'MQCONN' USING W02-MQM
                               W03-HCONN
                               W03-COMPCODE
                               W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQREMEXP: MQCONN ENDED WITH REASON ' W03-REASON
              STOP RUN
           END-IF.
      * OPEN THE DEAD_LETTER_Q FOR INPUT 
           MOVE MQOT-Q            TO MQOD-OBJECTTYPE.
           MOVE W02-OBJECT        TO MQOD-OBJECTNAME.
           COMPUTE W03-OPTIONS  = MQOO-BROWSE +
                                  MQOO-INPUT-SHARED.
           CALL 'MQOPEN' USING W03-HCONN
                               MQOD
                               W03-OPTIONS
                               W03-HOBJ
                               W03-COMPCODE
                               W03-REASON.

           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQREMEXP: MQOPEN ' W02-OBJECT 'ENDED WITH '
                                                W03-REASON
              PERFORM A-MAIN-DISCONNECT
           END-IF.
           COMPUTE MQGMO-OPTIONS = MQGMO-NO-WAIT +
                                   MQGMO-SYNCPOINT.
      * WE TRY TO MQGET A MESSAGE WITH A MESSAGE-ID AND CORREL-ID 
      * THAT WOULDN'T EXIST ON THE DEAD_LETTER_Q. SO PASSING OVER
      * THE EXPIRED AND NON EXPIRED MESSAGES ON THE Q SEARCHING
      * FOR A MESSAGE THAT DOES NOT EXIST, ALL EXPIRED MESSAGES 
      * WILL BE REMOVED FROM THE DEAD_LETTER_Q.
           MOVE TARGET-MSGID    TO MQMD-MSGID.
           MOVE TARGET-CORRELID TO MQMD-CORRELID.
           CALL 'MQGET' USING W03-HCONN
                              W03-HOBJ
                              MQMD
                              MQGMO
                              W03-BUFFER-LENGTH
                              W03-MESSAGE-BUFFER
                              W03-DATA-LENGTH
                              W03-COMPCODE
                              W03-REASON.
           IF W03-REASON = MQRC-NONE
               DISPLAY 'MQREMEXP: FIND TARGET MESSAGE WITH '
               DISPLAY 'MQREMEXP: MSGID    :' TARGET-MSGID
               DISPLAY 'MQREMEXP: CORRELID :' TARGET-CORRELID
               DISPLAY 'MQREMEXP: MESAJ    :' W03-MESSAGE-BUFFER
               CALL 'MQBACK' USING W03-HCONN
                                   W03-COMPCODE
                                   W03-REASON
               IF W03-REASON = MQRC-NONE
                  DISPLAY 'MQREMEXP: MQBACK ' W02-OBJECT ' ENDED '
                                                         W03-REASON
               END-IF
           ELSE
              DISPLAY 'MQREMEXP: MQGET ' W02-OBJECT 'ENDED '
                                                      W03-REASON
           END-IF.
           MOVE MQCO-NONE TO W03-OPTIONS.
           CALL 'MQCLOSE' USING W03-HCONN
                                W03-HOBJ
                                W03-OPTIONS
                                W03-COMPCODE
                                W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQREMEXP: CLOSE ' W02-OBJECT 'ENDED ' W03-REASON
           END-IF.
       MAIN-WORK-EXIT.
           PERFORM A-MAIN-DISCONNECT.
       A-MAIN-DISCONNECT.
           CALL 'MQDISC' USING W03-HCONN
                               W03-COMPCODE
                               W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQREMEXP: MQDISC ENDED WITH REASON' W03-REASON
           END-IF.
           STOP RUN.


CBL NODYNAM,LIB,OBJECT,RENT,RES,APOST
       IDENTIFICATION DIVISION.
       PROGRAM-ID. RUNMQDLQ.
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT       INFILE
               ORGANIZATION IS       SEQUENTIAL
               FILE STATUS  IS       FS
               ASSIGN       TO       INFILE.
       I-O-CONTROL.
       DATA DIVISION.
       FILE SECTION.
       FD  INFILE
           LABEL     RECORDS    ARE     STANDARD
           RECORDING MODE       IS      F
           BLOCK     CONTAINS   0       CHARACTERS
           RECORD    CONTAINS   80      CHARACTERS
           DATA      RECORD     IS      INFILE-REC.
       01  INFILE-REC.
           05  FILLER          PICTURE  X(80).
       WORKING-STORAGE SECTION.
       01  FS                    PICTURE XX.
       01  INFILE-STATUS         PICTURE X     VALUE SPACE.
           88  INFILE-END                      VALUE 'E'.
       01  INREC.
           05  INREC-ARRAY OCCURS 50 TIMES.
              10  INREC-VALUE-FLD.
                  15 INREC-FIELD      PICTURE X(20) VALUE SPACES.
                  15 INREC-VALUE      PICTURE X(48) VALUE SPACES.
              10  INREC-ACTION-FLD.
                  15 INREC-ACTION     PICTURE X(10) VALUE SPACES.
                  15 INREC-FWDQUEUE   PICTURE X(48) VALUE SPACES.
                  15 INREC-FWDQMGR    PICTURE X(48) VALUE SPACES.
      * THE PROCESS CAN BE DONE FOR GIVEN DESTINATION QUEUE NAMES, 
      * FOR ALL DESTINATION QUEUES OR FOR GIVEN DESTINATION QMANAGER
      * NAME       
       01  INREC-FIELDS.
           05  DESTQNAME         PICTURE X(20) VALUE 'DESTQNAME'.
           05  ALLQUEUES         PICTURE X(20) VALUE 'ALLQUEUES'.
           05  DESTQMGRNAME      PICTURE X(20) VALUE 'DESTQMGRNAME'.
      * 3 TYPES OF ACTION : RETRY, DISCARD, FORWARD
       01  INREC-ACTIONS.
           05  RETRY             PICTURE X(10) VALUE 'RETRY'.
           05  DISCARD           PICTURE X(10) VALUE 'DISCARD'.
           05  FORWARD           PICTURE X(10) VALUE 'FORWARD'.
       01  COMPARE-VALUE         PICTURE X(48).
       01  MATCH-STATUS          PICTURE X     VALUE SPACE.
           88  MATCH-FOUND                     VALUE 'E'.
       01  INDEKS                PICTURE 99 VALUE 0.
       01  I                     PICTURE 99 VALUE 0.
       01  W01-MQM-NAME                PIC X(48) VALUE SPACES.
       01  W01-QUEUE-NAME              PIC X(48) VALUE SPACES.
       01  W02-MQM                     PIC X(48) VALUE SPACES.
       01  W02-OBJECT                  PIC X(48) VALUE SPACES.
       01  W03-BUFFER-LENGTH           PIC S9(9) BINARY  VALUE 5198.
       01  W03-HCONN                   PIC S9(9) BINARY.
       01  W03-OPTIONS                 PIC S9(9) BINARY.
       01  W03-HOBJ                    PIC S9(9) BINARY.
       01  W03-HOBJ-OUT                PIC S9(9) BINARY.
       01  W03-DATA-LENGTH             PIC S9(9) BINARY.
       01  W03-COMPCODE                PIC S9(9) BINARY.
       01  W03-PUTCODE                 PIC S9(9) BINARY.
       01  W03-REASON                  PIC S9(9) BINARY.
       01  W03-MESSAGE-BUFFER.
           05 W03-DLQ-HEADER.
              COPY CMQDLHL.
           05 W03-MESSAGE-DATA         PIC X(5000).
       01  W05-MQM-OBJECT-DESCRIPTOR.
           COPY CMQODV.
       01  W05-MQM-MESSAGE-DESCRIPTOR.
           COPY CMQMDV.
       01  W05-MQM-GET-MESSAGE-OPTIONS.
           COPY CMQGMOV.
       01  W05-MQM-PUT-MESSAGE-OPTIONS.
           COPY CMQPMOV.
       01  W05-MQM-CONSTANTS.
           COPY CMQV.
       01  W06-CSQ4-OK             PIC S9(4) VALUE 0.
       01  W06-CSQ4-WARNING        PIC S9(4) VALUE 4.
       01  W06-CSQ4-ERROR          PIC S9(4) VALUE 8.
       LINKAGE SECTION.
       01  PARMDATA.
           05  PARM-LEN                PIC S9(03) BINARY.
           05  PARM-STRING             PIC X(100).
       PROCEDURE DIVISION USING PARMDATA.
       A-MAIN SECTION.
           PERFORM GET-PARAMETERS
              THRU GET-PARAMETERS-EXIT.
           PERFORM READ-INFILE
              THRU READ-INFILE-EXIT.
           PERFORM MAIN-WORK
              THRU MAIN-WORK-EXIT.
       GET-PARAMETERS.
      * QMANAGER NAME AND THE DEAD_LETTER_Q NAME SHOULB BE 
      * BE GIVEN AS INPUT PARAMETERS FROM THE INVOKED JCL
           IF PARM-LEN = 0 THEN
              DISPLAY 'NO PARAMAETER SPECIFIED'
              DISPLAY 'GIVE QMGRNAME AND DLQNAME SEPARATED BY COMMA'
              STOP RUN
           END-IF.
           UNSTRING PARM-STRING DELIMITED BY ALL ','
                                   INTO W02-MQM
                                        W02-OBJECT.
           MOVE W02-MQM    TO W01-MQM-NAME.
           MOVE W02-OBJECT TO W01-QUEUE-NAME.
           IF W02-MQM = SPACES OR W02-MQM = LOW-VALUES THEN
              DISPLAY 'DEFAULT QMGR USED'
           END-IF.
           IF W02-OBJECT = SPACES OR W02-OBJECT = LOW-VALUES THEN
              DISPLAY 'SPECIFY DLQ NAME'
              STOP RUN
           END-IF.
       GET-PARAMETERS-EXIT.
           EXIT.
       READ-INFILE.
      * WE READ THE INPUT FILE OF COMMANDS FOR PROCESSING THE DLQ
           OPEN INPUT INFILE.
           MOVE SPACE TO INFILE-STATUS.
           PERFORM SCAN-FILE
              THRU SCAN-FILE-EXIT
             UNTIL INFILE-END.
           CLOSE INFILE.
       READ-INFILE-EXIT.
           EXIT.
       SCAN-FILE.
           ADD 1 TO INDEKS.
      * WE READ THE INPUT FILE 2 LINES AT A TIME, FOR THE DESTINATION 
      * OBJECT NAME AND THE ACTION REQUESTED AND WE PUT EACH COMMAND 
      * ON AN ARRAY
                 READ INFILE NEXT
                AT END MOVE 'E' TO INFILE-STATUS.
           UNSTRING INFILE-REC DELIMITED BY ALL ','
                                  INTO INREC-FIELD (INDEKS)
                                       INREC-VALUE (INDEKS).
           READ INFILE NEXT
                AT END MOVE 'E' TO INFILE-STATUS.
           UNSTRING INFILE-REC DELIMITED BY ALL ','
                                  INTO INREC-ACTION   (INDEKS)
                                       INREC-FWDQUEUE (INDEKS)
                                       INREC-FWDQMGR  (INDEKS).
       SCAN-FILE-EXIT.
           EXIT.
       MAIN-WORK.
           CALL 'MQCONN' USING W02-MQM
                               W03-HCONN
                               W03-COMPCODE
                               W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQCONN ENDED WITH REASON ' W03-REASON
              STOP RUN
           END-IF.
           MOVE MQOT-Q            TO MQOD-OBJECTTYPE.
           MOVE W02-OBJECT        TO MQOD-OBJECTNAME.
           COMPUTE W03-OPTIONS  = MQOO-BROWSE +
                                  MQOO-INPUT-SHARED.
           CALL 'MQOPEN' USING W03-HCONN
                               MQOD
                               W03-OPTIONS
                               W03-HOBJ
                               W03-COMPCODE
                               W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQOPEN ' W02-OBJECT 'ENDED WITH ' W03-REASON
              PERFORM A-MAIN-DISCONNECT
           END-IF.
      * MQGET BROWSE FIRST MESSAGE
           MOVE MQGMO-NO-WAIT         TO MQGMO-OPTIONS.
           ADD  MQGMO-BROWSE-FIRST    TO MQGMO-OPTIONS.
           ADD  MQGMO-ACCEPT-TRUNCATED-MSG TO MQGMO-OPTIONS.
           CALL 'MQGET' USING W03-HCONN
                              W03-HOBJ
                              MQMD
                              MQGMO
                              W03-BUFFER-LENGTH
                              W03-MESSAGE-BUFFER
                              W03-DATA-LENGTH
                              W03-COMPCODE
                              W03-REASON.
      * LOOP UNTIL END OF MESSAGES
           PERFORM WITH TEST BEFORE
                   UNTIL ((W03-COMPCODE NOT = MQCC-OK) AND
                   (W03-REASON NOT = MQRC-TRUNCATED-MSG-ACCEPTED))
              PERFORM PROCESS-MESSAGE
                 THRU PROCESS-MESSAGE-EXIT
              MOVE MQMI-NONE TO MQMD-MSGID
              MOVE MQCI-NONE TO MQMD-CORRELID
              MOVE SPACES TO W03-MESSAGE-BUFFER
              MOVE MQGMO-NO-WAIT     TO MQGMO-OPTIONS
              ADD  MQGMO-BROWSE-NEXT TO MQGMO-OPTIONS
              ADD  MQGMO-ACCEPT-TRUNCATED-MSG TO MQGMO-OPTIONS
      * MQGET BROWSE NEXT MESSAGE
              CALL 'MQGET' USING W03-HCONN
                                 W03-HOBJ
                                 MQMD
                                 MQGMO
                                 W03-BUFFER-LENGTH
                                 W03-MESSAGE-BUFFER
                                 W03-DATA-LENGTH
                                 W03-COMPCODE
                                 W03-REASON
      * END LOOP
           END-PERFORM.
           IF ((W03-COMPCODE NOT = MQCC-OK) AND
              (W03-REASON NOT = MQRC-TRUNCATED-MSG-ACCEPTED)) THEN
              DISPLAY 'MQGET ' W02-OBJECT 'ENDED ' W03-REASON
           END-IF.
           MOVE MQCO-NONE TO W03-OPTIONS.
           CALL 'MQCLOSE' USING W03-HCONN
                                W03-HOBJ
                                W03-OPTIONS
                                W03-COMPCODE
                                W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'CLOSE ' W02-OBJECT 'ENDED ' W03-REASON
           END-IF.
       MAIN-WORK-EXIT.
           PERFORM A-MAIN-DISCONNECT.
       PROCESS-MESSAGE.
           MOVE 0 TO I.
           MOVE 'H' TO MATCH-STATUS.
      * FOR EACH MESSAGE BROWSED, LOOK IF IT IS SUBJECT TO THE
      * COMMANDS IN THE ARRAY
           PERFORM FIND-MATCH
              THRU FIND-MATCH-EXIT
             UNTIL I NOT < INDEKS OR MATCH-FOUND.
           IF MATCH-FOUND
              PERFORM TAKE-ACTION
                 THRU TAKE-ACTION-EXIT.
       PROCESS-MESSAGE-EXIT.
           EXIT.
       FIND-MATCH.
           ADD 1 TO I.
           EVALUATE INREC-FIELD (I)
              WHEN DESTQNAME
                 MOVE MQDLH-DESTQNAME TO COMPARE-VALUE
                 IF COMPARE-VALUE = INREC-VALUE (I)
                    MOVE 'E' TO MATCH-STATUS
                 END-IF
              WHEN ALLQUEUES
                 MOVE 'E' TO MATCH-STATUS
              WHEN DESTQMGRNAME
                 MOVE MQDLH-DESTQMGRNAME TO COMPARE-VALUE
                 IF COMPARE-VALUE = INREC-VALUE (I)
                    MOVE 'E' TO MATCH-STATUS
                 END-IF
           END-EVALUATE.
       FIND-MATCH-EXIT.
           EXIT.
       TAKE-ACTION.
           EVALUATE INREC-ACTION (I)
              WHEN DISCARD
                 PERFORM DISCARD-MESSAGE
                    THRU DISCARD-MESSAGE-EXIT
              WHEN RETRY
                 PERFORM RETRY-MESSAGE
                    THRU RETRY-MESSAGE-EXIT
              WHEN FORWARD
                 PERFORM FORWARD-MESSAGE
                    THRU FORWARD-MESSAGE-EXIT
           END-EVALUATE.
       TAKE-ACTION-EXIT.
           EXIT.
       A-MAIN-DISCONNECT.
           CALL 'MQDISC' USING W03-HCONN
                               W03-COMPCODE
                               W03-REASON.
           IF (W03-COMPCODE NOT = MQCC-OK) THEN
              DISPLAY 'MQDISC ENDED WITH REASON' W03-REASON
           END-IF.
           STOP RUN.
       DISCARD-MESSAGE.
           MOVE MQMI-NONE   TO MQMD-MSGID
           COMPUTE MQGMO-OPTIONS = MQGMO-NO-WAIT +
                                   MQGMO-MSG-UNDER-CURSOR.
           ADD  MQGMO-ACCEPT-TRUNCATED-MSG TO MQGMO-OPTIONS.
           CALL 'MQGET' USING W03-HCONN
                              W03-HOBJ
                              MQMD
                              MQGMO
                              W03-BUFFER-LENGTH
                              W03-MESSAGE-BUFFER
                              W03-DATA-LENGTH
                              W03-COMPCODE
                              W03-REASON
           IF W03-COMPCODE = MQCC-OK THEN
              CALL 'MQCMIT' USING W03-HCONN
                                  W03-COMPCODE
                                  W03-REASON
              IF W03-COMPCODE NOT = MQCC-OK THEN
                  DISPLAY 'CMIT' W02-OBJECT 'ENDED ' W03-REASON
              END-IF
           ELSE
              IF ((W03-COMPCODE NOT = MQCC-OK) AND
                 (W03-REASON NOT = MQRC-TRUNCATED-MSG-ACCEPTED)) THEN
                  DISPLAY 'GET ' W02-OBJECT 'ENDED ' W03-REASON
              END-IF
           END-IF.
       DISCARD-MESSAGE-EXIT.
           EXIT.
       RETRY-MESSAGE.
           MOVE MQCC-FAILED TO W03-PUTCODE.
           MOVE MQDLH-DESTQNAME       TO MQOD-OBJECTNAME.
           MOVE MQDLH-DESTQMGRNAME    TO MQOD-OBJECTQMGRNAME.
           PERFORM PUT-MESSAGE
              THRU PUT-MESSAGE-EXIT.
       RETRY-MESSAGE-EXIT.
           EXIT.
       FORWARD-MESSAGE.
           MOVE MQCC-FAILED TO W03-PUTCODE.
           MOVE INREC-FWDQUEUE (I)    TO MQOD-OBJECTNAME.
           MOVE INREC-FWDQMGR  (I)    TO MQOD-OBJECTQMGRNAME.
           PERFORM PUT-MESSAGE
              THRU PUT-MESSAGE-EXIT.
       FORWARD-MESSAGE-EXIT.
           EXIT.
       PUT-MESSAGE.
           MOVE MQOT-Q                TO MQOD-OBJECTTYPE.
           COMPUTE W03-OPTIONS = MQOO-OUTPUT.
           CALL 'MQOPEN' USING W03-HCONN
                               MQOD
                               W03-OPTIONS
                               W03-HOBJ-OUT
                               W03-COMPCODE
                               W03-REASON.
           IF W03-COMPCODE NOT = MQCC-OK
               DISPLAY 'OPEN ' MQOD-OBJECTNAME 'ENDED ' W03-REASON
           ELSE
               MOVE MQMT-DATAGRAM  TO MQMD-MSGTYPE
               MOVE MQDLH-FORMAT   TO MQMD-FORMAT
               SUBTRACT 172 FROM W03-DATA-LENGTH
               CALL 'MQPUT' USING  W03-HCONN
                                   W03-HOBJ-OUT
                                   MQMD
                                   MQPMO
                                   W03-DATA-LENGTH
                                   W03-MESSAGE-DATA
                                   W03-PUTCODE
                                   W03-REASON
               IF W03-PUTCODE = MQCC-OK
                   PERFORM DISCARD-MESSAGE
                      THRU DISCARD-MESSAGE-EXIT
               ELSE
                   DISPLAY 'PUT ' MQOD-OBJECTNAME 'ENDED ' W03-REASON
               END-IF
               CALL 'MQCLOSE' USING W03-HCONN
                                    W03-HOBJ-OUT
                                    MQCO-NONE
                                    W03-COMPCODE
                                    W03-REASON
               IF W03-COMPCODE NOT = MQCC-OK
                   DISPLAY 'CLOSE ' MQOD-OBJECTNAME 'ENDED' W03-REASON
               END-IF
           END-IF.
       PUT-MESSAGE-EXIT.
           EXIT.




//RUNMQDLQ JOB (ACCT),CLASS=1,MSGLEVEL=(1,1),
// NOTIFY=&SYSUID,MSGCLASS=X
//* THIS STEP WILL REMOVE ALL EXPIRED MESSAGES ON THE DLQ
//RUNMQEXP EXEC PGM=MQREMEXP,PARM=('PMQ1','PMQ1.DEAD.QUEUE')
//STEPLIB  DD   DSN=USER.TIS.LOADLIB,DISP=SHR
//         DD   DSN=SYS1.COB2LIB,DISP=SHR
//         DD   DSN=PMQM.SCSQANLE,DISP=SHR
//         DD   DSN=PMQM.SCSQAUTH,DISP=SHR
//         DD   DSN=PMQM.SCSQCOBC,DISP=SHR
//         DD   DSN=PMQM.SCSQLOAD,DISP=SHR
//SYSDBOUT DD   SYSOUT=*
//SYSABOUT DD   SYSOUT=*
//SYSPRINT DD   SYSOUT=*
//SYSOUT   DD   SYSOUT=*
//* THIS STEP WILL PROCESS UNEXPIRED MESSAGES
//RUNMQDLQ EXEC PGM=RUNMQDLQ,PARM=('PMQ1','PMQ1.DEAD.QUEUE')
//STEPLIB  DD   DSN=USER.TIS.LOADLIB,DISP=SHR
//         DD   DSN=SYS1.COB2LIB,DISP=SHR
//         DD   DSN=PMQM.SCSQANLE,DISP=SHR
//         DD   DSN=PMQM.SCSQAUTH,DISP=SHR
//         DD   DSN=PMQM.SCSQCOBC,DISP=SHR
//         DD   DSN=PMQM.SCSQLOAD,DISP=SHR
//SYSDBOUT DD   SYSOUT=*
//INFILE   DD   DSN=USER.TIS.JCL(MQDLQIN),DISP=SHR
//*    SAMPLE INPUT FILE CONTENT :
//*EACH COMMAND LIES ON TWO CONSECUTIVE LINES
//*1ST LINE : DESTQNAME,destination_Q_name
//*2ND LINE : action[,forwardq,forwardqmgr]
//* or 
//*1ST LINE : DESTQMGRNAME,destination_qmgr_name
//*2ND LINE : action[,forwardq,forwardqmgr]
//* or
//*1ST LINE : ALLQUEUES
//*2ND LINE : action[,forwardq,forwardqmgr]
//*DESTQNAME,YSP2CICS.INITQ
//*DISCARD
//*ALLQUEUES
//*RETRY
//*DESTQMGRNAME,MQ888
//*RETRY
//*DESTQNAME,CMON
//*FORWARD,BACKQ,MQ888
//SYSABOUT DD   SYSOUT=*
//SYSPRINT DD   SYSOUT=*
//SYSOUT   DD   SYSOUT=*


DESTQNAME,YSPCICS.INITQ
DISCARD
DESTQMGRNAME,MQ887
DISCARD
DESTQNAME,CMON
FORWARD,BACKQ,MQ887
ALLQUEUES
RETRY

